#
# Copyright (c) 1996,
# by Emanuel G. Noik
#
# Some simple Tcl utility procedures

#------------------------------------------------------------------------------

#  Generate unique strings.
#
set NextStringN(-1) -1;

proc ResetString {{prefix .w} {value -1}} {
   global NextStringN
   set NextStringN($prefix) $value
}

proc NextString {{prefix .w}} {
   global NextStringN
   if { [info exists NextStringN($prefix)] == 0 } {
      ResetString $prefix
   }
   return [format %s%d $prefix [incr NextStringN($prefix)]]
}

#------------------------------------------------------------------------------

#  Generate unique numbers.
#
set NextNumN(-1) -1;

proc ResetNum {key {value -1}} {
   global NextNumN
   set NextNumN($key) $value
}

proc NextNum {key} {
   global NextNumN
   if { [info exists NextNumN($key)] == 0 } {
      ResetNum $key
   }
   incr NextNumN($key)
   return $NextNumN($key)
}

#------------------------------------------------------------------------------

#  Remove first instance of matching element from a list.
#

proc RemoveElt {l elt} {
   upvar $l list
   set i [lsearch $list $elt]
   if { $i != -1 } {set list [lreplace $list $i $i]}
}

#------------------------------------------------------------------------------
